/*
 * Copyright (C) 2012  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <compiler.h>
#include <errno.h>
#include <string.h>
#include <pu-lib.h>
#include <pu-proto.h>
#include <pu-proto-lib.h>
#include <pu-buff.h>

int pu_proto_cmd(void *priv, struct pu_buff *skb)
{
	struct pu_header *hdr = (void *) skb->data;
	unsigned int command = be16_to_cpu(hdr->id);

	pu_skb_pull(skb, sizeof(*hdr));

	switch (command) {
	case PU_CMD_STAT:
		return pu_proto_stat(priv, skb);
	case PU_CMD_READ:
		return pu_proto_read(priv, skb);
	}
	return pu_proto_error(priv, skb, PU_ENOSYS);
}
